#define SubFileType				255
#define ImageWidth				256
#define ImageLength				257
#define RowsPerStrip			278
#define StripOffsets			273
#define StripByteCounts			279
#define SamplesPerPixel			277
#define BitsPerSample			258
#define PlanarConfiguration		284
#define Compression				259
#define Group3Options			292
#define FillOrder				266
#define Thresholding			263
#define CellWidth				264
#define CellLength				265
#define MinSampleValue			280
#define MaxSampleValue			281
#define PhotometricInterpretation	262
#define GrayResponseUnit		290
#define GrayResponseCurve		291
#define ColorResponseUnit		290
#define ColorResponseCurve		291
#define XResolution				282
#define YResolution				283
#define ResolutionUnit			296
#define Orientation				274


#define SHORT	3
#define LONG	4

struct	header
{
	char	byte_order[2];
	char	tiff_version[2];
	long	first_IFD;
}	tiff_header;

short	number_of_directories;
	
struct	directory_entry
{
	short	tag;
	short	type;
	long	count;
	union
	{
		short	short_value;
		long	long_value;
	} tag_value;
} tiff_directory, *ifd, *image_file_directory;


